# Shedskin Examples

79 programs that work with Shed Skin 0.9.9

## Example Overview

```
lines  name                 description
(sloccount)

   174 ac_encode.py         Arithmetic coding compressor
   130 adatron.py           Adatron SVM with polynomial kernel
   327 amaze.py             maze generator/solver
    84 ant.py               TSP approximation
   125 astar.py             a-star algorithm                (extmod, GUI)
   415 bh.py                barnes-hut force calculation
   222 block.py             Huffman block compressor
    54 brainfuck.py         brainfuck interpreter
  3600 c64_main.py          commodore 64 emulator           (extmod, GUI)
   220 chaos.py             chaosgame-like fractals
   321 chess.py             chess engine
   290 chull.py             3D convex hull
    65 circle.py            circle packing animation        (extmod, GUI)
    50 collatz.py           collatz record sequences
   105 dijkstra.py          dijkstra's algorithm
    80 dijkstra2.py         bidirectional dijkstra search
   666 doom.py              WAD rendering engine            (extmod, GUI)
   147 fysphun.py           physics animation               (extmod, GUI)
    92 genetic.py           genetic algorithm
   168 genetic2.py          another genetic algorithm
   300 go.py                go player (monte carlo/UCT)
   250 gs_main.py           wolfenstein-like 3d engine      (extmod, GUI)
  1539 hq2x.py              pixel art scaling               (linecount misleading, autogenerated code)
   329 kanoodle.py          Knuth's dancing links
   118 kmeanspp.py          K-means++ Clustering
    74 life.py              conway's game of life
   186 linalg.py            linear algebra
   270 loop.py              Havlak loop recognition algorithm
   190 LZ2.py               Lempel-Ziv compressor
    26 mandelbrot.py        mandelbrot fractal
   108 mandelbrot2_main.py  interactive mandelbrot fractal  (extmod, GUI)
   195 mao.py               raytracer (ao benchmark)
   223 mastermind_main.py   mastermind against comp         (extmod)
   117 mastermind2.py       mastermind strategies
   462 minilight.py         advanced raytracer
    49 minpng.py            uncompressed PNG encoder
 1,201 msp_ss.py            serial bootstrap loader
   482 mwmatching.py        maximum weighted matching algorithm
   101 nbody.py             planet body physics
   154 neural1.py           back-prop neural network
   109 neural2.py           back-prop neural network
    78 oliva2.py            sea shell patterns
    95 othello.py           othello player
   136 othello2.py          strong othello player
   208 path_tracing.py      path tracing raytracer
    80 pisang.py            satisfiability solver
   392 plcfrs.py            natural language parser
   244 pycsg_main.py        constructive solid geometry     (extmod)
  1543 pygasus_main.py      NES emulator                    (extmod, GUI)
   272 pygmy.py             raytracer
   218 pylife.py            hashlife-based game of life     (extmod, curses)
  1050 pylot_main.py        raytracer                       (extmod, GUI, multiprocessing)
   181 pystone.py           standard benchmark
  1181 quameon              quantum monte carlo algorithms
   469 rdb.py               iPod shuffle programmer
   286 richards.py          standard benchmark
    82 rsync.py             rsync algorithm
   846 rubik.py             rubik solver
    78 rubik2.py            thistlethwaite rubik solver
   259 sat.py               conflict-driven satisfiability solver
   129 score4.py            connect four/four-in-a-row
   192 sha.py               SHA-1 algorithm
    80 sieve.py             prime number sieves
    92 sokoban.py           sokoban solver
   102 solitaire.py         solitaire encryption algorithm
   200 stereo.py            stereo computer vision          (extmod, GUI)
   139 sudoku1.py           sudoku solver
   148 sudoku2.py           sudoku solver
   155 sudoku3.py           sudoku solver
    68 sudoku4.py           norvig's sudoku solver
    74 sudoku5.py           dancing links sudoku solver
   280 sunfish.py           chess engine
   113 tictactoe.py         tictactoe on large boards
   651 timsort.py           advanced sorting algorithm
   883 TarsaLZP.py          data compression algorithm
   753 TonyJpegDecoder.py   jpeg decoder
    39 voronoi.py           textual voronoi
   526 voronoi2.py          voronoi algoritm
   112 WebServer.py         simple web server
   276 yopyra.py            raytracer
```

If you know of any other interesting examples, please do suggest them in the shedskin discussion group or post an [issue](https://github.com/shedskin/shedskin/issues/new/choose) in the [Shedskin repo](https://github.com/shedskin/shedskin).


## Building and Running Individual Examples

Each example has its own directory which should contain the python code to be translated as well as related data files. Also a README.md if there are any special notes. In some cases, you may need to make a link to '../testdata'.

## Building all Examples

To build all examples:

```bash
shedskin test
```

To build a single example:

```bash
shedskin test --target <foldername>
```

For example to build the `timsort` example

```bash
shedskin test --target timsort
```



